<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "account_provider_emr".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AccountProviderEmr".
 *
 * Columns in table "account_provider_emr" available as properties of the model,
 * followed by relations of table "account_provider_emr" available as properties of the model.
 *
 * @property integer $id
 * @property integer $account_id
 * @property string $emr_user_id
 * @property string $emr_user_data
 * @property integer $provider_id
 *
 * @property Account $account
 * @property Provider $provider
 */
abstract class BaseAccountProviderEmr extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'account_provider_emr';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'AccountProviderEmr|AccountProviderEmrs', $n);
    }

    public static function representingColumn()
    {
        return 'emr_user_data';
    }

    public function rules()
    {
        return array(
            array('account_id', 'required'),
            array('account_id, provider_id', 'numerical', 'integerOnly' => true),
            array('emr_user_data', 'safe'),
            array('emr_user_id, emr_user_data, provider_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, account_id, emr_user_id, emr_user_data, provider_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'account' => array(self::BELONGS_TO, 'Account', array('account_id' => 'id')),
            'provider' => array(self::BELONGS_TO, 'Provider', array('provider_id' => 'id')),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'account_id' => null,
            'emr_user_id' => Yii::t('app', 'Emr User'),
            'emr_user_data' => Yii::t('app', 'Emr User Data'),
            'provider_id' => null,
            'account' => null,
            'provider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('emr_user_id', $this->emr_user_id);
        $criteria->compare('emr_user_data', $this->emr_user_data, true);
        $criteria->compare('provider_id', $this->provider_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
